// Tony Urschler
// November 2, 2021

#ifndef OSS_H
#define OSS_H

#define MAXSIZE 20

// resource descriptor struct
typedef struct {
    int initnum;
    int numremaining;
    int isSharable;
} rd_t;

// struct that holds overview of
// resource information
typedef struct {
    int available[20];
    int maximum[360];
    int allocation[360];
    int need[360];
    int request[360];
} rdoverview_t;

typedef struct {
    long mtype;
    char mtext[MAXSIZE];
} mymsg_t;

struct node {
    int lpid;
    int requestindex;
    int resourcenumber;
    struct node *next;
};

union semun {
    int                 val;
    struct semid_ds*    buf;
    unsigned short*     array;
#if defined(__linux__)
    struct seminfo* __buf;
#endif
};

// methods for bit array
#define SetBit(A, k)    ( A[(k/32)] |= (1 << (k%32)) )
#define ClearBit(A, k)  ( A[(k/32)] &= ~(1 << (k%32)) )
#define TestBit(A, k)   ( A[(k/32)] & (1 << (k%32)) )

#endif
