// Tony Urschler
// November 2, 2021

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/msg.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <time.h>
#include <unistd.h>
#include "config.h"
#include "oss.h"


int main(int argc, char *argv[]) {
    // getting the resource descriptors from shared memory
    int segment_id;
    segment_id = atoi(argv[1]);
    rd_t* rds;
    rds = (rd_t*) shmat(segment_id, NULL, 0);

    // getting the system clock
    segment_id = atoi(argv[2]);
    int* sysclock;
    sysclock = (int*) shmat(segment_id, NULL, 0);

    // getting msg queue id
    int msgid;
    msgid = atoi(argv[3]);

    // getting logical pid
    int lpid;
    lpid = atoi(argv[4]);

    // getting overview info
    segment_id = atoi(argv[5]);
    rdoverview_t* rdo;
    rdo = (rdoverview_t*) shmat(segment_id, NULL, 0);

    // getting semid
    int semid;
    semid = atoi(argv[6]);

    mymsg_t mymsg;

    // seeding with proc's pid
    srand(getpid() * time(0));

    // setting random needs for each resource
    int index = lpid * 20;
    for (int i = 0; i < 20; i++)
        rdo->need[index + i] = rand() % rds[i].initnum;

    // get proc initialized time
    struct sembuf sem_op;
    sem_op.sem_num = 0;
    sem_op.sem_op = -1;
    sem_op.sem_flg = 0;
    semop(semid, &sem_op, 1);
    int initsec = sysclock[0];
    int initns = sysclock[1];
    sem_op.sem_op = 1;
    semop(semid, &sem_op, 1);

    // set random interval to ask for stuff
    // between 0 and 250 milliseconds
    int interval = rand() % 250000000;
    int nextrequestsec = 0;
    int nextrequestns = 0;

    // set flag to know if its okay to start
    // terminating possibility
    int flag = 0;
    int nexttermchecksec;
    int nexttermcheckns;
    int terminterval;

    for (;;) {

        // get current time
        sem_op.sem_op = -1;
        semop(semid, &sem_op, 1);
        int currsec = sysclock[0];
        int currns = sysclock[1];
        sem_op.sem_op = 1;
        semop(semid, &sem_op, 1);
        
        // if term flag isn't set
        if (flag == 0) {
            // if a second or more has passed
            // set flag and see when next you
            // should check termination
            if ((currsec == initsec+1 && currns >= initns)
                    || currsec > initsec+1) {
                flag = 1;
                terminterval = rand() % 250000000;
                nexttermcheckns += terminterval;
                if (nexttermcheckns >= 1000000000) {
                    nexttermcheckns -= 1000000000;
                    nexttermchecksec += 1;
                }
            }
        }
        
        // if term flag is set
        if (flag == 1) {
            // if it's time to try and terminate
            if (currsec > nexttermchecksec+1 
                    || (currsec == nexttermchecksec && currns >= nexttermcheckns)) {
                // if terminate send message and leave loop
                if (rand() % 100 <= 15) {
                    mymsg.mtype = 22;
                    char *requesttype = "T";
                    int resource = 0;
                    snprintf(mymsg.mtext, 19, "%d %s %d", lpid, requesttype, resource);
                    int z = msgsnd(msgid, &mymsg, sizeof(mymsg), 0);
                    break;
                }            
            }
        }

        if (currsec > nextrequestsec+1
                || (currsec == nextrequestsec && currns >= nextrequestns)) {
            
            char *requesttype;
            int resource;

            // decide if the process will request or give a resource
            requesttype = (rand() % 100 < 50 && flag == 1) ? "G" : "R";
            if (requesttype == "G") {
                //select random resource and deallocate it
                resource = rand() % 20;
                int i;
                if (rdo->allocation[index+resource] == 0)
                    for (i = 0; i < 20; i++)
                        if (rdo->allocation[index+resource] != 0) {
                            resource = i;
                            break;
                        }
                // if the proc doesn't have any resources, request one
                if (i == 20)
                    requesttype = "R";
            }
            if (requesttype == "R") {
                while (rdo->need[index+resource] == 0) 
                    resource = rand() % 20;
                rdo->request[index + resource] = 
                    (rand() % rdo->need[index+resource]) + 1;
            }

            // send message to oss
            mymsg.mtype = 22;
            snprintf(mymsg.mtext, 19, "%d %s %d", lpid, requesttype, resource);
            int z = msgsnd(msgid, &mymsg, sizeof(mymsg), 0);
            if (z == -1) {
                perror("msgsend:");
                exit(1);
            }
            //printf("Child %d: sent\n", lpid);
            
            // wait for message from oss
            long msgwaittype = lpid + 2;
            msgrcv(msgid, &mymsg, sizeof(mymsg), msgwaittype, 0);
            nextrequestns += interval;
            if (nextrequestns >= 1000000000) {
                nextrequestns -= 1000000000;
                nextrequestsec += 1;
            }
        }
    }

    exit(EXIT_SUCCESS);
}

